blob: b5b42854e525aefc85f5bdd14efe14590db7fc11 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Alan Leungcf2de162018-03-30 20:18:20 +000048export USE_D8="true"
Igor Murashkin2a337752017-06-16 14:34:40 +000049export USE_DESUGAR="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070050export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070051
Alan Leungd5cbc562018-03-15 14:02:46 -070052# If d8 was not set by the environment variable, assume it is in the path.
53if [ -z "$D8" ]; then
54 export D8="d8"
55fi
56
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070057# If dx was not set by the environment variable, assume it is in the path.
58if [ -z "$DX" ]; then
59 export DX="dx"
60fi
61
Alan Leungd5cbc562018-03-15 14:02:46 -070062export DXMERGER="$D8"
63
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080064# If jasmin was not set by the environment variable, assume it is in the path.
65if [ -z "$JASMIN" ]; then
66 export JASMIN="jasmin"
67fi
68
Andreas Gampe8fda9f22014-10-03 16:15:37 -070069# If smali was not set by the environment variable, assume it is in the path.
70if [ -z "$SMALI" ]; then
71 export SMALI="smali"
72fi
73
Sebastien Hertz19ac0272015-02-24 17:39:50 +010074# ANDROID_BUILD_TOP is not set in a build environment.
75if [ -z "$ANDROID_BUILD_TOP" ]; then
76 export ANDROID_BUILD_TOP=$oldwd
77fi
78
Andreas Gampef47fb2f2016-06-24 22:30:29 -070079# ANDROID_HOST_OUT is not set in a build environment.
80if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsenf325e012017-03-03 12:35:30 -080081 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070082fi
83
Igor Murashkine5181932017-06-15 16:03:50 -070084# Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false.
Igor Murashkind3232772017-06-22 14:54:13 -070085if [ -z "$DESUGAR" ]; then
Igor Murashkine5181932017-06-15 16:03:50 -070086 export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh"
87fi
88
Igor Murashkin271a0f82017-02-14 21:14:17 +000089# Zipalign is not on the PATH in some configs, auto-detect it.
90if [ -z "$ZIPALIGN" ]; then
91 if which zipalign >/dev/null; then
92 ZIPALIGN="zipalign";
93 else
94 # TODO: Add a dependency for zipalign in Android.run-test.mk
95 # once it doesn't depend on libandroidfw (b/35246701)
96 case "$OSTYPE" in
97 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
98 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
99 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
100 esac
101 fi
102fi
103export ZIPALIGN
104
David Brazdil122c6632018-01-24 17:32:49 +0000105# If hiddenapi was not set by the environment variable, assume it is in
106# ANDROID_HOST_OUT.
David Brazdil11b67b22018-01-18 16:41:40 +0000107if [ -z "$HIDDENAPI" ]; then
David Brazdil122c6632018-01-24 17:32:49 +0000108 export HIDDENAPI="${ANDROID_HOST_OUT}/bin/hiddenapi"
David Brazdil11b67b22018-01-18 16:41:40 +0000109fi
110
Roland Levillain76cfe612017-10-30 13:14:28 +0000111chroot=
112
jeffhao5d1ac922011-09-29 17:41:15 -0700113info="info.txt"
114build="build"
115run="run"
116expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700117check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700118output="output.txt"
119build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100120cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700121strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700122lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700123testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700124run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000125build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700126
Alex Light91de25f2015-10-28 17:00:06 -0700127quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000128debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700129prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700130target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700131dev_mode="no"
132update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700133debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000134relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800135runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700136usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700137build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700138suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700139trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700140trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700141basic_verify="false"
142gc_verify="false"
143gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700144jvmti_trace_stress="false"
Alex Light43e935d2017-06-19 15:40:40 -0700145jvmti_field_stress="false"
Alex Lightc38c3692017-06-27 15:45:14 -0700146jvmti_step_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700147jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700148strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700149always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700150never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700151have_dex2oat="yes"
152have_patchoat="yes"
153have_image="yes"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800154multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000155android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700156bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800157suspend_timeout="500000"
Alex Light10bc5a42016-05-10 10:01:22 -0700158# By default we will use optimizing.
159image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000160image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700161
162while true; do
163 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700164 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700165 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100166 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700167 shift
Alex Light91de25f2015-10-28 17:00:06 -0700168 elif [ "x$1" = "x--quiet" ]; then
169 quiet="yes"
170 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700171 elif [ "x$1" = "x--use-java-home" ]; then
172 if [ -n "${JAVA_HOME}" ]; then
173 export JAVA="${JAVA_HOME}/bin/java"
174 export JAVAC="${JAVA_HOME}/bin/javac -g"
175 else
176 echo "Passed --use-java-home without JAVA_HOME variable set!"
177 usage="yes"
178 fi
179 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800180 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700181 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800182 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800183 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700184 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700185 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700186 NEED_DEX="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100187 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700188 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800189 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700190 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700191 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700192 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700193 shift
194 elif [ "x$1" = "x--dalvik" ]; then
195 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800196 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700197 shift
Alex Light03a112d2014-08-25 13:25:56 -0700198 elif [ "x$1" = "x--no-dex2oat" ]; then
199 have_dex2oat="no"
200 shift
201 elif [ "x$1" = "x--no-patchoat" ]; then
202 have_patchoat="no"
203 shift
204 elif [ "x$1" = "x--no-image" ]; then
205 have_image="no"
206 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800207 elif [ "x$1" = "x--multi-image" ]; then
208 multi_image_suffix="-multi"
209 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700210 elif [ "x$1" = "x--pic-test" ]; then
211 run_args="${run_args} --pic-test"
212 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700213 elif [ "x$1" = "x--relocate" ]; then
214 relocate="yes"
215 shift
216 elif [ "x$1" = "x--no-relocate" ]; then
217 relocate="no"
218 shift
219 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100220 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700221 prebuild_mode="yes"
222 shift;
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800223 elif [ "x$1" = "x--compact-dex-level" ]; then
224 option="$1"
225 shift
226 run_args="${run_args} $option $1"
227 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700228 elif [ "x$1" = "x--strip-dex" ]; then
229 run_args="${run_args} --strip-dex"
230 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000231 elif [ "x$1" = "x--debuggable" ]; then
232 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000233 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000234 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700235 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100236 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700237 prebuild_mode="no"
238 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700239 elif [ "x$1" = "x--gcverify" ]; then
240 basic_verify="true"
241 gc_verify="true"
242 shift
243 elif [ "x$1" = "x--gcstress" ]; then
244 basic_verify="true"
245 gc_stress="true"
246 shift
Alex Lightc38c3692017-06-27 15:45:14 -0700247 elif [ "x$1" = "x--jvmti-step-stress" ]; then
248 jvmti_step_stress="true"
249 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700250 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
251 jvmti_redefine_stress="true"
252 shift
Alex Light43e935d2017-06-19 15:40:40 -0700253 elif [ "x$1" = "x--jvmti-field-stress" ]; then
254 jvmti_field_stress="true"
255 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700256 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
257 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700258 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800259 elif [ "x$1" = "x--suspend-timeout" ]; then
260 shift
261 suspend_timeout="$1"
262 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700263 elif [ "x$1" = "x--image" ]; then
264 shift
265 image="$1"
266 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700267 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000268 elif [ "x$1" = "x-Xcompiler-option" ]; then
269 shift
270 option="$1"
271 run_args="${run_args} -Xcompiler-option $option"
272 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000273 elif [ "x$1" = "x--build-option" ]; then
274 shift
275 option="$1"
276 build_args="${build_args} $option"
277 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700278 elif [ "x$1" = "x--runtime-option" ]; then
279 shift
280 option="$1"
281 run_args="${run_args} --runtime-option $option"
282 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700283 elif [ "x$1" = "x--gdb-arg" ]; then
284 shift
285 gdb_arg="$1"
286 run_args="${run_args} --gdb-arg $gdb_arg"
287 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700288 elif [ "x$1" = "x--debug" ]; then
289 run_args="${run_args} --debug"
290 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700291 elif [ "x$1" = "x--debug-wrap-agent" ]; then
292 run_args="${run_args} --debug-wrap-agent"
293 shift
Alex Light0e151e72017-10-25 10:50:35 -0700294 elif [ "x$1" = "x--with-agent" ]; then
295 shift
296 option="$1"
297 run_args="${run_args} --with-agent $1"
298 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700299 elif [ "x$1" = "x--debug-agent" ]; then
300 shift
301 option="$1"
302 run_args="${run_args} --debug-agent $1"
303 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700304 elif [ "x$1" = "x--gdb" ]; then
305 run_args="${run_args} --gdb"
306 dev_mode="yes"
307 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700308 elif [ "x$1" = "x--strace" ]; then
309 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700310 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700311 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700312 elif [ "x$1" = "x--zygote" ]; then
313 run_args="${run_args} --zygote"
314 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800315 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000316 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700317 image_suffix="-interpreter"
318 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800319 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700320 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000321 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800322 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700323 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700324 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800325 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700326 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700327 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700328 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700329 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700330 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700331 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700332 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700333 elif [ "x$1" = "x--no-optimize" ]; then
334 run_args="${run_args} --no-optimize"
335 shift
336 elif [ "x$1" = "x--no-precise" ]; then
337 run_args="${run_args} --no-precise"
338 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700339 elif [ "x$1" = "x--invoke-with" ]; then
340 shift
341 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700342 if [ "x$what" = "x" ]; then
343 echo "$0 missing argument to --invoke-with" 1>&2
344 usage="yes"
345 break
346 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700347 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700348 shift
349 elif [ "x$1" = "x--dev" ]; then
350 run_args="${run_args} --dev"
351 dev_mode="yes"
352 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700353 elif [ "x$1" = "x--build-only" ]; then
354 build_only="yes"
355 shift
356 elif [ "x$1" = "x--output-path" ]; then
357 shift
358 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700359 if [ "x$tmp_dir" = "x" ]; then
360 echo "$0 missing argument to --output-path" 1>&2
361 usage="yes"
362 break
363 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700364 shift
Roland Levillain76cfe612017-10-30 13:14:28 +0000365 elif [ "x$1" = "x--chroot" ]; then
366 shift
367 if [ "x$1" = "x" ]; then
368 echo "$0 missing argument to --chroot" 1>&2
369 usage="yes"
370 break
371 fi
372 chroot="$1"
373 run_args="${run_args} --chroot $1"
374 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000375 elif [ "x$1" = "x--android-root" ]; then
376 shift
377 if [ "x$1" = "x" ]; then
378 echo "$0 missing argument to --android-root" 1>&2
379 usage="yes"
380 break
381 fi
382 android_root="$1"
383 run_args="${run_args} --android-root $1"
384 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700385 elif [ "x$1" = "x--update" ]; then
386 update_mode="yes"
387 shift
388 elif [ "x$1" = "x--help" ]; then
389 usage="yes"
390 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700391 elif [ "x$1" = "x--64" ]; then
392 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700393 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700394 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200395 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700396 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200397 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700398 elif [ "x$1" = "x--stream" ]; then
399 trace_stream="true"
400 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700401 elif [ "x$1" = "x--always-clean" ]; then
402 always_clean="yes"
403 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700404 elif [ "x$1" = "x--never-clean" ]; then
405 never_clean="yes"
406 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800407 elif [ "x$1" = "x--dex2oat-swap" ]; then
408 run_args="${run_args} --dex2oat-swap"
409 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700410 elif [ "x$1" = "x--instruction-set-features" ]; then
411 shift
412 run_args="${run_args} --instruction-set-features $1"
413 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700414 elif [ "x$1" = "x--bisection-search" ]; then
415 bisection_search="yes"
416 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000417 elif [ "x$1" = "x--vdex" ]; then
418 run_args="${run_args} --vdex"
419 shift
Nicolas Geoffraybaeaa9b2018-01-26 14:31:17 +0000420 elif [ "x$1" = "x--dm" ]; then
421 run_args="${run_args} --dm"
422 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000423 elif [ "x$1" = "x--vdex-filter" ]; then
424 shift
425 filter=$1
426 run_args="${run_args} --vdex-filter $filter"
427 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700428 elif [ "x$1" = "x--random-profile" ]; then
429 run_args="${run_args} --random-profile"
430 shift
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700431 elif [ "x$1" = "x--dex2oat-jobs" ]; then
432 shift
433 run_args="${run_args} -Xcompiler-option -j$1"
434 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700435 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700436 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700437 usage="yes"
438 break
439 else
440 break
441 fi
442done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700443
Orion Hodson6aa4e0d2018-05-25 09:39:16 +0100444if [ "$usage" = "no" -a "x$1" = "x" ]; then
445 echo "missing test to run" 1>&2
446 usage="yes"
447fi
448
Roland Levillain76cfe612017-10-30 13:14:28 +0000449# The DEX_LOCATION with the chroot prefix, if any.
450chroot_dex_location="$chroot$DEX_LOCATION"
451
Alex Light10bc5a42016-05-10 10:01:22 -0700452run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700453# Allocate file descriptor real_stderr and redirect it to the shell's error
454# output (fd 2).
455if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
456 exec {real_stderr}>&2
457else
458 # In bash before version 4.1 we need to do a manual search for free file
459 # descriptors.
460 FD=3
461 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
462 real_stderr=$FD
463 eval "exec ${real_stderr}>&2"
464fi
465if [ "$quiet" = "yes" ]; then
466 # Force the default standard output and error to go to /dev/null so we will
467 # not print them.
468 exec 1>/dev/null
469 exec 2>/dev/null
470fi
471
472function err_echo() {
473 echo "$@" 1>&${real_stderr}
474}
475
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700476# tmp_dir may be relative, resolve.
477#
478# Cannot use realpath, as it does not exist on Mac.
Roland Levillain76cfe612017-10-30 13:14:28 +0000479# Cannot use a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700480# Cannot use readlink -m, as it does not exist on Mac.
481# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700482noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700483tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700484mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700485
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800486# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000487if [ ! "$runtime" = "jvm" ]; then
488 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
489fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800490
Alex Lighte7873ec2014-08-12 09:53:50 -0700491if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800492 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
493 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700494fi
495if [ "$gc_verify" = "true" ]; then
496 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
497fi
498if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700499 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700500fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700501if [ "$jvmti_redefine_stress" = "true" ]; then
502 run_args="${run_args} --no-app-image --jvmti-redefine-stress"
503fi
Alex Lightc38c3692017-06-27 15:45:14 -0700504if [ "$jvmti_step_stress" = "true" ]; then
505 run_args="${run_args} --no-app-image --jvmti-step-stress"
506fi
Alex Light43e935d2017-06-19 15:40:40 -0700507if [ "$jvmti_field_stress" = "true" ]; then
508 run_args="${run_args} --no-app-image --jvmti-field-stress"
509fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700510if [ "$jvmti_trace_stress" = "true" ]; then
511 run_args="${run_args} --no-app-image --jvmti-trace-stress"
Alex Light8f2c6d42017-04-10 16:27:35 -0700512fi
Jeff Hao85139a32014-07-23 11:52:52 -0700513if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700514 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
515 if [ "$trace_stream" = "true" ]; then
516 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
517 # the ability to analyze the file and just write to /dev/null.
518 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
519 # Enable streaming mode.
520 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
521 else
522 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
523 fi
524elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700525 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700526 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700527fi
528
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700529# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000530# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100531function guess_target_arch_name() {
Andreas Gamped0566d42018-06-06 09:54:34 -0700532 # Check whether this is a device with native bridge. Currently this is hardcoded
533 # to x86 + arm.
534 x86_arm=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | sort | grep -E '^(arm|x86)$'`
535 # Collapse line-breaks into spaces
536 x86_arm=$(echo $x86_arm)
537 if [ "x$x86_arm" = "xarm x86" ] ; then
538 err_echo "Native-bridge configuration detected."
539 # We only support the main arch for tests.
540 if [ "x${suffix64}" = "x64" ]; then
541 target_arch_name=""
542 else
543 target_arch_name=x86
544 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700545 else
Andreas Gamped0566d42018-06-06 09:54:34 -0700546 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
547 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
548 if [ "x${suffix64}" = "x64" ]; then
549 target_arch_name=${grep64bit}
550 else
551 target_arch_name=${grep32bit}
552 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700553 fi
554}
555
David Brazdil853a4c32015-09-28 16:15:50 +0100556function guess_host_arch_name() {
557 if [ "x${suffix64}" = "x64" ]; then
558 host_arch_name="x86_64"
559 else
560 host_arch_name="x86"
561 fi
562}
563
Alex Lighta59dd802014-07-02 16:28:08 -0700564if [ "$target_mode" = "no" ]; then
565 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700566 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700567 err_echo "--prebuild with --jvm is unsupported"
Roland Levillain76cfe612017-10-30 13:14:28 +0000568 exit 1
569 fi
570 else
571 # ART/Dalvik host mode.
572 if [ -n "$chroot" ]; then
573 err_echo "--chroot with --host is unsupported"
574 exit 1
Alex Lighta59dd802014-07-02 16:28:08 -0700575 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700576 fi
577fi
578
Alex Light03a112d2014-08-25 13:25:56 -0700579if [ "$have_patchoat" = "no" ]; then
580 run_args="${run_args} --no-patchoat"
581fi
582
583if [ "$have_dex2oat" = "no" ]; then
584 run_args="${run_args} --no-dex2oat"
585fi
586
Jeff Hao201803f2013-11-20 18:11:39 -0800587if [ ! "$runtime" = "jvm" ]; then
588 run_args="${run_args} --lib $lib"
589fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700590
Jeff Hao201803f2013-11-20 18:11:39 -0800591if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700592 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000593 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800594 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700595 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700596 else
597 true # defaults to using target BOOTCLASSPATH
598 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800599elif [ "$runtime" = "art" ]; then
600 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100601 guess_host_arch_name
Richard Uhlerbb00f812017-02-16 14:21:10 +0000602 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700603 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800604 else
David Brazdil853a4c32015-09-28 16:15:50 +0100605 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800606 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Richard Uhlerbb00f812017-02-16 14:21:10 +0000607 run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800608 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700609 if [ "$relocate" = "yes" ]; then
610 run_args="${run_args} --relocate"
611 else
612 run_args="${run_args} --no-relocate"
613 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700614elif [ "$runtime" = "jvm" ]; then
615 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800616 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700617fi
618
Alex Light03a112d2014-08-25 13:25:56 -0700619if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700620 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700621 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700622 exit 1
623 fi
Alex Light03a112d2014-08-25 13:25:56 -0700624 run_args="${run_args} --no-image"
625fi
626
jeffhao5d1ac922011-09-29 17:41:15 -0700627if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700628 err_echo "--dev and --update are mutually exclusive"
629 usage="yes"
630fi
631
632if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
633 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700634 usage="yes"
635fi
636
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700637if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
638 err_echo "--bisection-search and --prebuild are mutually exclusive"
639 usage="yes"
640fi
641
642if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then
643 err_echo "--bisection-search and --no-dex2oat are mutually exclusive"
644 usage="yes"
645fi
646
647if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
648 err_echo "--bisection-search and --no-patchoat are mutually exclusive"
649 usage="yes"
650fi
651
Roland Levillain76cfe612017-10-30 13:14:28 +0000652# TODO: Chroot-based bisection search is not supported yet (see below); implement it.
653if [ "$bisection_search" = "yes" -a -n "$chroot" ]; then
654 err_echo "--chroot with --bisection-search is unsupported"
655 exit 1
656fi
657
jeffhao5d1ac922011-09-29 17:41:15 -0700658if [ "$usage" = "no" ]; then
659 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
660 test_dir=`basename "$oldwd"`
661 else
662 test_dir="$1"
663 fi
664
665 if [ '!' -d "$test_dir" ]; then
666 td2=`echo ${test_dir}-*`
667 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700668 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700669 usage="yes"
670 fi
671 test_dir="$td2"
672 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700673 # Shift to get rid of the test name argument. The rest of the arguments
674 # will get passed to the test run.
675 shift
676fi
677
Søren Gjesse620d0a52016-09-19 11:12:51 +0200678# For building with javac and dx always use Java 7. The dx compiler
679# only support byte codes from Java 7 or earlier (class file major
680# version 51 or lower).
Orion Hodson4a1cac42018-05-23 16:23:27 +0100681if [ "$NEED_DEX" = "true" ]; then
Søren Gjesse620d0a52016-09-19 11:12:51 +0200682 export JAVAC="${JAVAC} -source 1.7 -target 1.7"
683fi
684
jeffhao5d1ac922011-09-29 17:41:15 -0700685if [ "$usage" = "yes" ]; then
686 prog=`basename $prog`
687 (
688 echo "usage:"
689 echo " $prog --help Print this message."
690 echo " $prog [options] [test-name] Run test normally."
691 echo " $prog --dev [options] [test-name] Development mode" \
692 "(dumps to stdout)."
693 echo " $prog --update [options] [test-name] Update mode" \
694 "(replaces expected.txt)."
695 echo ' Omitting the test name or specifying "-" will use the' \
696 "current directory."
697 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000698 echo " -O Run non-debug rather than debug build (off by default)."
699 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000700 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000701 echo " --runtime-option Pass an option to the runtime."
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800702 echo " --compact-dex-level Specify a compact dex level to the compiler."
Alex Lightc281ba52017-10-11 11:35:55 -0700703 echo " --debug Wait for the default debugger to attach."
704 echo " --debug-agent <agent-path>"
705 echo " Wait for the given debugger agent to attach. Currently"
706 echo " only supported on host."
707 echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props"
708 echo " to load the debugger agent specified by --debug-agent."
Alex Light0e151e72017-10-25 10:50:35 -0700709 echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000710 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000711 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700712 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000713 echo " --build-only Build test files only (off by default)."
714 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800715 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000716 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000717 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700718 echo " --verify-soft-fail Force soft fail verification (off by default)."
719 echo " Verification is enabled if neither --no-verify"
720 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000721 echo " --no-optimize Turn off optimization (on by default)."
722 echo " --no-precise Turn off precise GC (on by default)."
723 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700724 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000725 echo " other runtime options are ignored."
726 echo " --no-dex2oat Run as though dex2oat was failing."
727 echo " --no-patchoat Run as though patchoat was failing."
728 echo " --prebuild Run dex2oat on the files before starting test. (default)"
729 echo " --no-prebuild Do not run dex2oat on the files before starting"
730 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700731 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000732 echo " --relocate Force the use of relocating in the test, making"
733 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000734 echo " address before running."
735 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700736 echo " --image Run the test using a precompiled boot image. (default)"
737 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000738 echo " --host Use the host-mode virtual machine."
739 echo " --invoke-with Pass --invoke-with option to runtime."
740 echo " --dalvik Use Dalvik (off by default)."
741 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700742 echo " --use-java-home Use the JAVA_HOME environment variable"
743 echo " to find the java compiler and runtime"
744 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000745 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700746 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000747 echo " --64 Run the test in 64-bit mode"
748 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700749 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700750 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000751 echo " --gcstress Run with gc stress testing"
752 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700753 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
Alex Lightc38c3692017-06-27 15:45:14 -0700754 echo " --jvmti-step-stress Run with jvmti single step stress testing"
Alex Lightb7edcda2017-04-27 13:20:31 -0700755 echo " --jvmti-redefine-stress"
756 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000757 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700758 echo " --never-clean Keep the test files even if the test succeeds."
Roland Levillain76cfe612017-10-30 13:14:28 +0000759 echo " --chroot [newroot] Run with root directory set to newroot."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000760 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000761 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700762 echo " --instruction-set-features [string]"
763 echo " Set instruction-set-features for compilation."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800764 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
765 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700766 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700767 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700768 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000769 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800770 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700771 echo " --dex2oat-jobs Number of dex2oat jobs."
Alex Light91de25f2015-10-28 17:00:06 -0700772 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700773 exit 1
774fi
775
776cd "$test_dir"
777test_dir=`pwd`
778
779td_info="${test_dir}/${info}"
780td_expected="${test_dir}/${expected}"
781
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700782if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700783 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700784 exit 1
785fi
786
787if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700788 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700789 exit 1
790fi
791
792# copy the test to a temp dir and run it
793
Elliott Hughes510c8782011-10-06 10:57:34 -0700794echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700795
796rm -rf "$tmp_dir"
797cp -Rp "$test_dir" "$tmp_dir"
798cd "$tmp_dir"
799
800if [ '!' -r "$build" ]; then
801 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800802else
803 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700804fi
805
806if [ '!' -r "$run" ]; then
807 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800808else
809 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700810fi
811
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700812if [ '!' -r "$check_cmd" ]; then
813 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800814else
815 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700816fi
817
jeffhao5d1ac922011-09-29 17:41:15 -0700818chmod 755 "$build"
819chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700820chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700821
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700822export TEST_NAME=`basename ${test_dir}`
823
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000824# Tests named '<number>-checker-*' will also have their CFGs verified with
825# Checker when compiled with Optimizing on host.
826if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
827 if [ "$runtime" = "art" -a "$image_suffix" = "" ]; then
828 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
829 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
830 run_checker="yes"
831
832 if [ "$target_mode" = "no" ]; then
833 cfg_output_dir="$tmp_dir"
834 checker_args="--arch=${host_arch_name^^}"
835 else
836 cfg_output_dir="$DEX_LOCATION"
837 checker_args="--arch=${target_arch_name^^}"
838 fi
839
840 if [ "$debuggable" = "yes" ]; then
841 checker_args="$checker_args --debuggable"
842 fi
843
844 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
845 -Xcompiler-option -j1"
846 fi
847 fi
848fi
849
Mathieu Chartier031768a2015-08-27 10:25:02 -0700850 run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700851
Richard Uhler020c0f32017-03-14 16:23:17 +0000852# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
853# ART output to approximately 128MB. This should be more than sufficient
854# for any test while still catching cases of runaway output.
855# Set a hard limit to encourage ART developers to increase the ulimit here if
856# needed to support a test case rather than resetting the limit in the run
857# script for the particular test in question.
Orion Hodsonbd328d32017-03-24 11:24:10 +0000858if ! ulimit -f 128000; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000859 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700860fi
861
Igor Murashkin2de6e082018-02-28 15:25:23 -0800862# Tell the build script which mode (target, host, jvm) we are building for
863# to determine the bootclasspath at build time.
Igor Murashkin2a337752017-06-16 14:34:40 +0000864if [[ "$target_mode" == "yes" ]]; then
865 build_args="$build_args --target"
866else
Igor Murashkin2de6e082018-02-28 15:25:23 -0800867 if [[ $runtime == "jvm" ]]; then
868 build_args="$build_args --jvm"
869 else
870 build_args="$build_args --host"
871 fi
Igor Murashkin2a337752017-06-16 14:34:40 +0000872fi
873
874if [[ "$dev_mode" == "yes" ]]; then
875 build_args="$build_args --dev"
876fi
877
jeffhao5d1ac922011-09-29 17:41:15 -0700878good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000879good_build="yes"
880good_run="yes"
Alex Light77fee872017-09-05 14:51:49 -0700881export TEST_RUNTIME="${runtime}"
jeffhao5d1ac922011-09-29 17:41:15 -0700882if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000883 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700884 build_exit="$?"
885 echo "build exit status: $build_exit" 1>&2
886 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800887 echo "${test_dir}: running..." 1>&2
888 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700889 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000890
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800891 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000892 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100893 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000894 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100895 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100896 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000897 checker_exit="$?"
898 if [ "$checker_exit" = "0" ]; then
899 good="yes"
900 fi
Alex Light91de25f2015-10-28 17:00:06 -0700901 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000902 else
903 good="yes"
904 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800905 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000906 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700907 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700908elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000909 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700910 build_exit="$?"
911 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800912 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700913 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000914 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100915 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000916 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100917 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100918 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000919 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700920 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
921 good="yes"
922 else
Alex Light91de25f2015-10-28 17:00:06 -0700923 cat "$build_output" 1>&${real_stderr} 1>&2
924 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700925 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700926elif [ "$build_only" = "yes" ]; then
927 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000928 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700929 build_exit="$?"
930 if [ "$build_exit" '!=' '0' ]; then
931 cp "$build_output" "$output"
932 echo "build exit status: $build_exit" >>"$output"
933 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
934 if [ "$?" '!=' "0" ]; then
935 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700936 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700937 fi
938 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700939 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700940 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700941 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700942else
David Brazdil4846d132015-01-15 19:07:08 +0000943 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700944 build_exit="$?"
945 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800946 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700947 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000948 run_exit="$?"
949 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700950 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000951 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000952 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100953 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000954 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100955 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100956 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000957 checker_exit="$?"
958 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700959 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000960 good_run="no"
961 else
962 good_run="yes"
963 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000964 else
965 good_run="yes"
966 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700967 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000968 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700969 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700970 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
971 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700972 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700973 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700974 max_name_length=$(getconf NAME_MAX ${tmp_dir})
975 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
976 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700977 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700978 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700979 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700980 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000981 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
982 # output == expected
983 good="yes"
984 echo "${test_dir}: succeeded!" 1>&2
985 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700986 fi
987fi
988
jeffhao5d1ac922011-09-29 17:41:15 -0700989(
Alex Lightbfac14a2014-07-30 09:41:21 -0700990 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700991 echo "${test_dir}: FAILED!"
992 echo ' '
993 echo '#################### info'
994 cat "${td_info}" | sed 's/^/# /g'
995 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700996 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700997 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700998 if [ "$strace" = "yes" ]; then
999 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -07001000 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -07001001 echo '####################'
1002 fi
Andreas Gampee79ca192017-07-31 10:30:16 -07001003 if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then
1004 # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The
1005 # tools used by the given ABI work for both x86 and x86-64.
1006 echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000
1007 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001008 echo ' '
1009 fi
Alex Lightbfac14a2014-07-30 09:41:21 -07001010
Alex Light91de25f2015-10-28 17:00:06 -07001011) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -07001012
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001013# Attempt bisection only if the test failed.
Roland Levillain76cfe612017-10-30 13:14:28 +00001014# TODO: Implement support for chroot-based bisection search.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001015if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
1016 # Bisecting works by skipping different optimization passes which breaks checker assertions.
1017 if [ "$run_checker" == "yes" ]; then
1018 echo "${test_dir}: not bisecting, checker test." 1>&2
1019 else
1020 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001021 echo "${test_dir}: bisecting..." 1>&2
1022 cwd=`pwd`
1023 maybe_device_mode=""
1024 raw_cmd=""
1025 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001026 # Produce cmdline.sh in $chroot_dex_location. "$@" is passed as a runtime option
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001027 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
1028 # to exec in order to preserve pid when calling dalvikvm. This is required
1029 # for bisection search to correctly retrieve logs from device.
1030 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
Roland Levillain76cfe612017-10-30 13:14:28 +00001031 adb shell chmod u+x "$chroot_dex_location/cmdline.sh"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001032 maybe_device_mode="--device"
1033 raw_cmd="$DEX_LOCATION/cmdline.sh"
1034 else
1035 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
1036 fi
Roland Levillain76cfe612017-10-30 13:14:28 +00001037 # TODO: Pass a `--chroot` option to the bisection_search.py script and use it there.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001038 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
1039 $maybe_device_mode \
1040 --raw-cmd="$raw_cmd" \
1041 --check-script="$cwd/check" \
1042 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -07001043 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001044 --timeout=300
1045 fi
1046fi
1047
Alex Lightbfac14a2014-07-30 09:41:21 -07001048# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -07001049if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -07001050 cd "$oldwd"
1051 rm -rf "$tmp_dir"
1052 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001053 adb shell rm -rf $chroot_dex_location
Alex Lightbfac14a2014-07-30 09:41:21 -07001054 fi
1055 if [ "$good" = "yes" ]; then
1056 exit 0
1057 fi
1058fi
1059
1060
1061(
1062 if [ "$always_clean" = "yes" ]; then
1063 echo "${TEST_NAME} files deleted from host "
1064 if [ "$target_mode" == "yes" ]; then
1065 echo "and from target"
1066 fi
1067 else
1068 echo "${TEST_NAME} files left in ${tmp_dir} on host"
1069 if [ "$target_mode" == "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001070 echo "and in ${chroot_dex_location} on target"
Alex Lightbfac14a2014-07-30 09:41:21 -07001071 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -07001072 fi
1073
Alex Light91de25f2015-10-28 17:00:06 -07001074) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -07001075
Alex Light6a870fa2016-05-31 16:36:19 -07001076if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
1077 exit 0
1078else
1079 exit 1
1080fi